-
Notifications
You must be signed in to change notification settings - Fork 43
/
CombinationSum.java
318 lines (272 loc) · 9.51 KB
/
CombinationSum.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
package LeetCodeJava.BackTrack;
// https://leetcode.com/problems/combination-sum/
import java.util.*;
public class CombinationSum {
// attr
List<List<Integer>> res = new ArrayList<>();
HashSet<List<Integer>> set = new HashSet<>();
// V0
// IDEA : BACKTRACK
public List<List<Integer>> combinationSum(int[] candidates, int target) {
if (candidates == null || candidates.length == 0){
return null;
}
// NOTE !!! we sore here
Arrays.sort(candidates);
List<List<Integer>> res = new ArrayList<>();
List<Integer> tmp = new ArrayList<>();
int idx = 0;
backTrack(candidates, target, tmp, res, idx);
return res;
}
private void backTrack(int[] candidates, int target, List<Integer> tmp, List<List<Integer>> res, int idx){
if (getSum(tmp) == target){
tmp.sort(Comparator.comparing(x -> x));
if (!res.contains(tmp)){
res.add(new ArrayList<>(tmp));
}
return;
}
if (getSum(tmp) > target){
return;
}
// backtrack logic
// NOTE !!! have to start from "start" idx
for (int i = idx; i < candidates.length; i++){
int cur = candidates[i];
tmp.add(cur);
/** NOTE !!!
*
* use i, since we need to use start from current (i) index in recursion call
* (reuse current index)
*/
/** NOTE !!!
*
* we have to set i starts from "start" idx
* since we have to reuse same element in recursion call
*
* ONLY 全排列 (Permutations) can go without "start" idx
*/
backTrack(candidates, target, tmp, res, i);
// undo
tmp.remove(tmp.size()-1);
}
}
private int getSum(List<Integer> input){
if (input == null || input.size() == 0){
return 0;
}
int res = 0;
for (Integer x : input){
res += x;
}
return res;
}
// V0'
// IDEA : BACKTRACK (GPT)
List<List<Integer>> res_0 = new ArrayList<>();
public List<List<Integer>> combinationSum_0(int[] candidates, int target) {
List<Integer> cur = new ArrayList<>();
//Arrays.sort(candidates); // Optional: sort to improve efficiency
backtrack_0(candidates, target, cur, res_0, 0);
return res_0;
}
public void backtrack_0(int[] candidates, int target, List<Integer> cur, List<List<Integer>> res, int start) {
if (getSum_0(cur) == target) {
res.add(new ArrayList<>(cur)); // Add a copy of the current list
return;
}
if (getSum(cur) > target) {
return;
}
// NOTE !!! have to start from "start" idx
for (int i = start; i < candidates.length; i++) {
cur.add(candidates[i]);
/** NOTE !!!
*
* we have to set i starts from "start" idx
* since we have to reuse same element in recursion call
*
* ONLY 全排列 (Permutations) can go without "start" idx
*/
backtrack_0(candidates, target, cur, res, i); // Not i+1 because we can reuse the same elements
cur.remove(cur.size() - 1); // Undo the last addition
}
}
public int getSum_0(List<Integer> cur) {
int res = 0;
for (int x : cur) {
res += x;
}
return res;
}
// V0'
// IDEA : BACKTRACK
/**
* Example output :
* candidates = [2, 3, 5]
*
* -> output:
*
* i = 0 cur = []
* i = 0 cur = [2]
* i = 0 cur = [2, 2]
* i = 0 cur = [2, 2, 2]
* i = 1 cur = [2, 2, 2]
* i = 2 cur = [2, 2, 2]
* i = 1 cur = [2, 2]
* i = 1 cur = [2, 2, 3]
* i = 2 cur = [2, 2, 3]
* i = 2 cur = [2, 2]
* i = 1 cur = [2]
* i = 1 cur = [2, 3]
* i = 2 cur = [2, 3]
* i = 2 cur = [2]
* i = 2 cur = [2, 5]
* i = 1 cur = []
* i = 1 cur = [3]
* i = 1 cur = [3, 3]
* i = 2 cur = [3, 3]
* i = 2 cur = [3]
* i = 2 cur = []
* i = 2 cur = [5]
*
*/
public List<List<Integer>> combinationSum_(int[] candidates, int target) {
// sort
Arrays.sort(candidates);
//Arrays.stream(candidates).forEach(System.out::println);
if (candidates[0] > target){
return res;
}
List<Integer> cur = new ArrayList<>();
help(candidates, target, cur, 0);
return res;
}
private void help(int[] candidates, int target, List<Integer> cur, int idx){
if (getSum(cur) == target){
Collections.sort(cur);
if (!set.contains(cur)){
set.add(cur);
// NOTE : make a deep copy
res.add(new ArrayList<>(cur));
return;
}
}
if (getSum_(cur) > target){
return;
}
for (int i = idx; i < candidates.length; i++){
//System.out.println("i = " + i + " cur = " + cur);
int _val = candidates[i];
cur.add(_val);
// NOTE here : use i, instead of idx + 1
help(candidates, target, cur, i);
// NOTE : we remove last element, instead of first one
cur.remove(cur.size()-1);
}
}
private Integer getSum_(List<Integer> input){
int sum = 0;
for (Integer x : input){
sum += x;
}
return sum;
}
// V1
// IDEA : BACKTRACK
// https://leetcode.com/problems/subsets/solutions/27281/a-general-approach-to-backtracking-questions-in-java-subsets-permutations-combination-sum-palindrome-partitioning/
public List<List<Integer>> combinationSum_1(int[] nums, int target) {
List<List<Integer>> list = new ArrayList<>();
Arrays.sort(nums);
_backtrack(list, new ArrayList<>(), nums, target, 0);
return list;
}
private void _backtrack(List<List<Integer>> list, List<Integer> tempList, int [] nums, int remain, int start){
if(remain < 0) return;
else if(remain == 0) list.add(new ArrayList<>(tempList));
else{
for(int i = start; i < nums.length; i++){
tempList.add(nums[i]);
_backtrack(list, tempList, nums, remain - nums[i], i); // not i + 1 because we can reuse same elements
tempList.remove(tempList.size() - 1);
}
}
}
// V1
// IDEA : BACKTRACK
// https://leetcode.com/problems/combination-sum/editorial/
protected void backtrack(
int remain,
LinkedList<Integer> comb,
int start, int[] candidates,
List<List<Integer>> results) {
if (remain == 0) {
// make a deep copy of the current combination
results.add(new ArrayList<Integer>(comb));
return;
} else if (remain < 0) {
// exceed the scope, stop exploration.
return;
}
for (int i = start; i < candidates.length; ++i) {
// add the number into the combination
comb.add(candidates[i]);
this.backtrack(remain - candidates[i], comb, i, candidates, results);
// backtrack, remove the number from the combination
comb.removeLast();
}
}
public List<List<Integer>> combinationSum_2(int[] candidates, int target) {
List<List<Integer>> results = new ArrayList<List<Integer>>();
LinkedList<Integer> comb = new LinkedList<Integer>();
this.backtrack(target, comb, 0, candidates, results);
return results;
}
// V2
// https://www.youtube.com/watch?v=GBKI9VSKdGg
// https://github.com/neetcode-gh/leetcode/blob/main/java/0039-combination-sum.java
public List<List<Integer>> combinationSum_3(int[] candidates, int target) {
List<List<Integer>> ans = new ArrayList<List<Integer>>();
List<Integer> cur = new ArrayList();
backtrack(candidates, target, ans, cur, 0);
return ans;
}
public void backtrack(
int[] candidates,
int target,
List<List<Integer>> ans,
List<Integer> cur,
int index
) {
if (target == 0) {
ans.add(new ArrayList(cur));
} else if (target < 0 || index >= candidates.length) {
return;
} else {
cur.add(candidates[index]);
backtrack(candidates, target - candidates[index], ans, cur, index);
cur.remove(cur.get(cur.size() - 1));
backtrack(candidates, target, ans, cur, index + 1);
}
}
// V3
// https://leetcode.com/problems/combination-sum/solutions/3804814/java-easy-solution-using-backtracking/
public List<List<Integer>> combinationSum_4(int[] candidates, int target) {
List<List<Integer>> list = new ArrayList<>();
Arrays.sort(candidates);
backtrack(list, new ArrayList<>(), candidates, target, 0);
return list;
}
public void backtrack(List<List<Integer>> list, List<Integer> temp, int[] nums, int remain, int start) {
if(remain < 0) return;
else if (remain == 0) list.add(new ArrayList<>(temp));
else {
for(int i = start; i < nums.length; i ++) {
temp.add(nums[i]);
backtrack(list, temp, nums, remain - nums[i], i);
temp.remove(temp.size() - 1);
}
}
}
}